#!/bin/bash
#
# $Revision: 1.20 $, $Date: 2004/02/09 09:15:58 $
#
# GPL, mimooh at pld-linux.org
# TPSA DSL ethernet modem

run_main () {
	install_if_missing rp-pppoe
	line_replace "ETH" "ETH=$eth" /etc/ppp/pppoe.conf
	line_replace "USER" "USER=$user" /etc/ppp/pppoe.conf
	line_replace "CONNECT_TIMEOUT" "CONNECT_TIMEOUT=0" /etc/ppp/pppoe.conf
	line_replace "RETRY_ON_FAILURE" "RETRY_ON_FAILURE=yes" /etc/ppp/pppoe.conf

	echo "$user * $pass" > /etc/ppp/pap-secrets
	line_replace "alias char-major-108 ppp_generic" "alias char-major-108 ppp_generic" $MODULES_CONFIG
	line_replace "adsl-start" "adsl-start" /etc/rc.d/rc.local
	/usr/sbin/adsl-stop
	/usr/sbin/adsl-start
}

eval `dml<< EOF
<meta title="$(nls "TPSA DSL setup")" width=68 height=14><br><br>
$(nls "Network card"): <input id=eth caption=eth0 width=8><br><br>
$(nls "user"):  <input id=user caption=bolek@tpsa.pl width=25><br><br>
$(nls "password"): <input id=pass caption=zapomnialem width=25><br><br>
<br>
\`dml_buttons Ok Anuluj Pomoc Wyjcie\`
<button id=dml_delete caption="$(nls "Remove configuration")"><br>
EOF`

dml_cancel_check ${DATA_DIR}/NET/net_menu.sh
dml_help_check ${DATA_DIR}/POMOC/README_tpsa_dsl.txt
dml_check_the_rest ${DATA_DIR}/NET/net_menu.sh 

if [ $delete = "yes" ]
then
	TMPFILE=`mktemp /tmp/pldconf.XXXXXX` || exit 1
	cp /etc/rc.d/rc.local $TMPFILE
	grep -v adsl-start $TMPFILE > /etc/rc.d/rc.local
	exec ${DATA_DIR}/NET/net_menu.sh
	rm $TMPFILE
fi

