#!/bin/bash
# $Revision: 1.1 $, $Date: 2003/10/25 12:41:02 $
# GPL, bonder at pld-linux.org, mimooh at pld-linux.org
# The script can set up to $max_cards ethernet cards 

max_cards=5
create_dml_entries()
{
	while read junk dev rest; do
		while read id module name; do
			[ "$id" = "$dev" ] && found_modules=$found_modules:$module
		done < /usr/share/pci-database/net.pci
	done < /proc/bus/pci/devices

	for ((i=0,j=2; $i<$max_cards; i++,j++)); do
		unset IPADDR BOOTPROTO
		[ -f "/etc/sysconfig/interfaces/ifcfg-eth$i" ] && . /etc/sysconfig/interfaces/ifcfg-eth$i
		detected_ip=`echo $IPADDR | cut -d\/ -f1`
		detected_prefix=`echo $IPADDR | cut -d\/ -f2`
		detected_module=`echo $found_modules | cut -f$j -d:` # ie. found_modules=:dmfe:e100
		[ "X$BOOTPROTO" = "Xdhcp" ] && detected_dhcp=1 || detected_dhcp=0
		[ -z "$detected_prefix" ] && [ "X$detected_dhcp" = "X0" ] && detected_prefix=auto
		[ -n "$detected_module" ] || detected_module="nie_wykryto"

		dml_entry="eth$i   $(nls "IP address"): <input id=IP_$i caption=$detected_ip width=17>
	 	   $(nls "Module"): <input caption=$detected_module id=MODULE_$i width=13><br>
		        $(nls "Mask"):    <input id=PREFIX_$i caption=$detected_prefix width=17>
		    <check id=DHCP_$i checked=$detected_dhcp> $(nls "get from DHCP")<br>
		-------------------------------------------------------------<br>"
		dml_entries="$dml_entries $dml_entry"
	done
}


exit_func(){
	echo "$(nls "Configured cards"): $y"
	/etc/rc.d/init.d/network stop
	sudo rmmod `echo $found_modules | sed s/:/\ /g` # needed when more cards
	sleep $SLEEP_TIME
	/etc/rc.d/init.d/network start
}

run_main()
{
	if [ "X$PCMCIA" = "Xyes" ]; then
		install_if_missing "pcmcia-cs kernel-grsecurity-pcmcia-cs"
		/etc/rc.d/init.d/pcmcia restart 
		#This line prevents "MODULE = nie_wykryto" test for just eth0
		MODULE_0=yenta_socket
	fi

	for ((y=0; $y<$max_cards; y++)); do
		eval IP="\$IP_$y" PREFIX="\$PREFIX_$y" MODULE="\$MODULE_$y" DHCP="\$DHCP_$y"

		[ -z "$MODULE" ] || [ "X$MODULE" = "Xnie_wykryto" ] && { exit_func; return; }
		[ -z "$IP" ] && [ "X$DHCP" != "Xyes" ] && { show_message "eth$y: $(nls "No IP / DHCP")"; return; }

		[ -z "$PREFIX" ] || [ "X$PREFIX" = "Xauto" ] && { eval `ipcalc -m $IP`; count_prefix "$NETMASK"; }
		echo $PREFIX | grep "\." && count_prefix "$PREFIX" # decimal mask
		
		[ "X$DHCP" = "Xyes" ] && { unset IP PREFIX; DHCP="dhcp"; install_if_missing dhcpcd; } || DHCP="none"

		line_replace "alias eth$y" "alias eth$y $MODULE" $MODULES_CONFIG
		cat > /etc/sysconfig/interfaces/ifcfg-eth$y << EOF 
#Device name
DEVICE="eth$y"

#IP address
IPADDR="$IP/$PREFIX"

#Activate on boot? yes|no
ONBOOT="yes"

# dhcp|pump|none
BOOTPROTO="$DHCP"
EOF
	show_verbose_message "$(nls "After changes in /etc/sysconfig/interfaces/ifcfg-eth$y")" "cat /etc/sysconfig/interfaces/ifcfg-eth$y"
	done
	exit_func
}

gui()
{
	eval `dml << EOF
	<meta title="$(nls "Ethernet card setup")" width=68><br><br>
	$dml_entries
	<check id=PCMCIA> $(nls "Enable PCMCIA services (ignore all errors about detecting modules)")<br>
	<br><br>
	\`dml_buttons Ok Anuluj Edytuj Pomoc Wyjcie\`<br>
EOF`
	
	dml_cancel_check ${DATA_DIR}/NET/net_menu.sh
	dml_help_check ${DATA_DIR}/POMOC/README_ethernet.txt 
	dml_edit_check /etc/sysconfig/interfaces/ifcfg-eth0 
	dml_check_the_rest ${DATA_DIR}/NET/net_menu.sh
}

create_dml_entries
gui
