#/bin/bash
#
# $Revision: 1.7 $, $Date: 2004/02/15 14:50:58 $, $Author: teodor $
#
# GPL, teodor at pld-linux.org, mimooh at pld-linux.org
# This script is used to dial number and connect with internet by
# wvdial. It also show number of impulses and connection cost

if [ -f $HOME_ETC/.pldconf/cost ]; then
	. $HOME_ETC/.pldconf/cost
else
	# if ther is no options use default
	sec_normal=180
	sec_max=360
	# majority exchanges are digital, 15 seconds sholud be enough
	sleep_init=15
	impuls_cost=31
	hour_std_start=8
	hour_std_stop=18
fi

cost_edit() {
	eval `dml << EOF
	<meta title="$(nls "Cost edit")"><br>
	$(nls "Normal impulse every"):               <input id=sec_normal caption=$sec_normal width=4> $(nls "sec.")
	<br>
	$(nls "Cheap impuls every"):                 <input id=sec_max caption=$sec_max width=4> $(nls "sec."). <br>
	<br>
	$(nls "Negotiation time"): <input id=sleep_init caption=$sleep_init width=4> $(nls "sec.")
	<br><br>
	$(nls "Impuls cost"):                      <input id=impuls_cost caption=$impuls_cost width=4> 
	$(nls "$") <br><br>
	$(nls "Normal telephone tariff"):         <input id=hour_std_start caption=$hour_std_start 
	width=4><br>
	                $(nls "to"):         <input id=hour_std_stop caption=$hour_std_stop 
	width=4><br><br>
	<button id=save caption=$(nls "Save")> <button id=dml_cancel caption=$(nls "Cancel")>
EOF`
	if [ $save = "yes" ]; then
		# Looking for .pldconf folder, if there isn't, create it
		if [ ! -d $HOME_ETC/.pldconf/cost ]; then
			mkdir $HOME_ETC/.pldconf 2> /dev/null
		fi
		# Save to cost file
		cat > $HOME_ETC/.pldconf/cost << EOF
sec_normal=$sec_normal
sec_max=$sec_max
sleep_init=$sleep_init
impuls_cost=$impuls_cost
hour_std_start=$hour_std_start
hour_std_stop=$hour_std_stop
EOF
	fi
}

impulses_interval () {
	hour_now=`date +%k`
	day_week=`date +%u`

	if [ $hour_now -lt $hour_std_stop ] && [ $hour_now -gt $hour_std_start ] \
		&& [ $day_week -lt 6 ]; then
		sleep_time=$sec_normal
	else
 		sleep_time=$sec_max
	fi
}

count_time_func () {
	impulses=1
	sleep $sleep_init
	cost="0.31"
	while [ 1 ]; do
		impulses_interval
		clear
		echo "$(nls "impulses"): $impulses	`date +%R:%S`"
		echo "$(nls "cost"): $cost"
		sleep $sleep_time
		impulses=$(($impulses + 1))
		grosz=$(($impulses*$impuls_cost))
		cost=$(($grosz/100))"."$(($grosz%100))"z"
	done
}

group_items () {
	[ ! -f /etc/wvdial.conf ] && { echo "<item id=null> $(nls "No ISP")"; } || {
		cat /etc/wvdial.conf | grep Dialer | perl -pe "s/\[Dialer //g; s/\]//g" | \
		while read group; do
			echo "<item id=$group>_$group"
		done
	}
}


run_main () {
	if [ "$licznik" = "yes" ]; then
 		${EXEC_PREFIX}/wvdial $isp & 
		count_time_func
	else
		${EXEC_PREFIX}/wvdial $isp 
	fi
}

gui () {
	eval `dml << EOF
	<meta title="$(nls "Connect")">
	$(nls "Select operator"):
	<menu id=isp>
	\`group_items\`
	</menu><br>
	<check id=licznik> $(nls "Show time connect")<br><br>
	<button id=edycja_kosztow caption="$(nls "Edit cost")"> <br><br>
	\`dml_buttons Ok Anuluj Pomoc Wyjcie\`
EOF`
	
	dml_help_check ${DATA_DIR}/POMOC/README_isp.txt
	dml_check_the_rest ${EXEC_PREFIX}/pldconf
	dml_cancel_check ${EXEC_PREFIX}/pldconf
	
	if [ $edycja_kosztow = "yes" ]; then
	 	cost_edit
		exec ${DATA_DIR}/NET/wvdial_connect.sh
	fi

}

command_help () {
	cat << EOF
$(nls "Help")
	
	pldconf -m       [$(nls "connection name")]
	pldconf -m help  - $(nls "help")
	pldconf -M       - $(nls "show GUI")

	$(nls "Connections"):
EOF
	[ ! -f /etc/wvdial.conf ] && { echo "                $(nls "no ISP")"; } || {
		cat /etc/wvdial.conf | grep Dialer | perl -pe "s/\[Dialer //g; \s/\]//g" | \
		while read group; do
		echo "          $group" 
	
		done
	}
}

if [ ! "$1" ]; then
	gui
else
	# Check if selected ISP is in wvdial.conf file, if not show
	# help. If there is no options also show help.
	
	if [ "$1" = "help" ]; then
		command_help
	elif [ -f /etc/wvdial.conf ] && [ "`grep "\[Dialer $1\]" /etc/wvdial.conf`" ]; then
		isp=$1
		licznik="yes"
		run_main
	else
		echo "$(nls "$1 - not found in /etc/wvdial.conf")"
		command_help
	fi
fi
