#!/bin/bash
# 
# aumix.sh	Simple module for setting up mixer settings
# 
# Author:	Jakub Krajniak <teodor at pld-linux.org>
# Licence:	GPL
#
# $Revision$
#

run_main () {
	install_if_missing aumix
	add_entries
	backup_file $HOME/.$SHELLRC
	line_replace "aumix"  "aumix -L >/dev/null 2>&1"  $HOME/.$SHELLRC
	aumix -L
}

add_entries () {
	backup_file $HOME_ETC/.aumixrc
	cat > $HOME_ETC/.aumixrc << EOF 
vol:$vol:$vol
pcm:$pcm:$pcm
pcm2:$pcm:$pcm
line:$linein:$linein
cd:$cd:$cd
mic:$mic:$mic
EOF
}

gui () {
	eval `dml<< EOF
	<meta title="$(nls "Mixer settings")"><br>
	$(nls "Chanels"): <br><br>
	Vol     <input id=vol caption=80 width=5> (0..100)<br>
	Wav     <input id=pcm caption=80 width=5> (0..100)<br>
	LineIN  <input id=linein caption=50 width=5> (0..100)<br>
	CD      <input id=cd caption=80 width=5> (0..100)<br>
	Mic     <input id=mic caption=0 width=5> (0..100)<br><br>
	<check id=mute_all checked=0> $(nls "Mute all") <br>
	\`dml_buttons Ok Anuluj Edytuj Wyjcie Przywr\`
EOF`
	[ $mute_all = "yes" ] && vol=0
	dml_cancel_check ${EXEC_PREFIX}/pldconf
	dml_check_the_rest ${EXEC_PREFIX}/pldconf
	dml_edit_check ${HOME_ETC}/.aumixrc
	dml_recover_check $HOME_ETC/.pldconf/.aumixrc $HOME_ETC/.aumixrc
}
gui
