#!/bin/bash
# editor.sh	This module is responisble for setting up default editor
#
# Author:	Jakub Krajniak <teodor at pld-linux.org>
# Changes:	Karol Kreski <mimooh at pld-linux.org>
# Licence:	GPL
# 
# $Id:$
#

run_main () {
	install_if_missing $editor
	backup_file $HOME/.$SHELLPROFILE
	line_replace "export EDITOR" "export EDITOR=$editor" $HOME/.$SHELLPROFILE
	if [ "X$mc_colors" = "Xyes" ]; then
		line_replace "export MC_COLOR_TABLE=" "export MC_COLOR_TABLE=:editnormal=$mc_fg,$mc_bg" ~/.$SHELLPROFILE
	fi
	show_message "$(nls "Changes will work after next login")"
}

gui () {
	eval `dml<< EOF
	<meta title="$(nls "Editors")"><br>
	$(nls "Defaults editors:") <br>
	<menu id=editor>
	<item id=vim> vim
	<item id=mcedit> mcedit
	<item id=nano> nano
	<item id=pico> pico
	<item id=joe> joe
	<item id=jed> jed
	</menu><br>
	<check id=mc_colors> $(nls "Colors for mcedit"): <input id=mc_fg caption="green" width=12> / <input id=mc_bg caption="black" width=10><br>
	<button id=mc_colors_list caption="$(nls "Colors list")"><br><br>
	\`dml_buttons Ok Anuluj Pomoc Przywr Wyjcie\`
EOF`
	
	if [ "X$mc_colors_list" = "Xyes" ]; then
		TIMEOUT_MODE=0 # make sure show_message waits for <enter>
		show_message "mcedit colors: \nblack \ngray \nred \nbrightred \ngreen \nbrightgreen \nbrown \nyellow \nblue \nbrightblue \nmagenta \nbrightmagenta \ncyan \nbrightcyan \nlightgray \nwhite"
		exec $0
	fi
	dml_cancel_check ${EXEC_PREFIX}/pldconf
	dml_check_the_rest ${EXEC_PREFIX}/pldconf
	dml_help_check ${DATA_DIR}/POMOC/README_$editor.txt
	dml_recover_check $HOME_ETC/.pldconf/.$SHELLPROFILE ~/.$SHELLPROFILE
}

gui
