#!/bin/bash
#GPL, mimooh at pld-linux.org

run_main()
{
	[ "X$poldek_shell" = "Xyes" ] && /usr/bin/poldek

	[ "X$sync" = "Xyes" ] && poldek --up || poldek --upa

	[ "X$inst_all" = "Xyes" ] && {
		edytory=yes; X=yes; 
		net=yes; inne=yes; info=yes; devel=yes
	}
	[ "X$edytory" = "Xyes" ] && packets="$packets vim joe mc pico nano jed"

	[ "X$X" = "Xyes" ] && {
		gfx_module="`pcidev /m gfx`"
		show_message "$(nls "Seems like the best driver for you card is: $gfx_module.  You can try with other X11-driver-foo if this one doesnt't work.  Nvidia can be used with both nvidia/nv driver.  You may also need kernel-video-foo for closed drivers.")"
		packets="$packets X11 X11-fonts X11-fonts-ISO8859-2 X11-fonts-75dpi-ISO8859-2 X11-fonts-100dpi-ISO8859-2 X11-tools X11-driver-$gfx_module"
	}

	[ "X$smb" = "Xyes" ] && packets="$packets samba samba-client smbc"

	[ "X$boot"  = "Xyes" ] && packets="$packets grub chkconfig"

	[ "X$inne" = "Xyes" ] && packets="$packets poink sudo rdate psmisc man info"

	[ "X$info" = "Xyes" ] && packets="$packets pciutils less nmap"

	[ "X$devel" = "Xyes" ] && packets="$packets kernel-grsecurity-headers autoconf automake gcc glibc-devel libstdc++-devel glibc-static"

	[ "X$poldek_fetch" = "Xyes" ] && poldek --shcmd="get $poldek_file_fetch"

	[ "$install_packets_command_line" ] && packets="$packets $install_packets_command_line"

	[ -n "$packets" ] && install_packets "$packets"
}

gui()
{
	eval `dml<< EOF
	<meta title="$(nls "Add/remove programs")" width=70><br>
 	<button id="poldek_conf" caption="$(nls "Setup")"> <button id="poldek_shell" caption="$(nls "Add/remove programs")"> <button id="sync" caption="$(nls "Synchronize index")"><br>
	------------------------------------------------------------------<br>
	$(nls "Install packages for sections below using poldek:")<br>
	<check id=edytory> $(nls "Editors") (vim/joe/mcedit/pico/nano/jed)<br>
	<check id=X> X11<br>
	<check id=inne> $(nls "Other") (sudo/rdate/psmisc/man/info/poink)<br>
	<check id=info> $(nls "About system") (pciutils/less/nmap)<br>
	<check id=devel> $(nls "Devel packages") (gcc & friends)<br>
	<check id=poldex> $(nls "Poldex (very nice frontend for poldek)")<br>
	<button id=instaluj caption="$(nls "Install selected")"> <button id=inst_all caption="$(nls "Install all")">
	<br><br><button id=poldek_fetch caption=$(nls "Download")> $(nls "package") <input id=poldek_file_fetch caption=coreutils width=16>.rpm
	<br>------------------------------------------------------------------<br>
	\`dml_buttons Anuluj Pomoc Wyjcie\`
EOF`

	[ "X$poldek_conf" = "Xyes" ] && exec ${DATA_DIR}/poldek_conf.sh
	if [ "X$poldek_shell" = "Xyes" ] || [ "X$sync" = "Xyes" ] || [ "X$instaluj" = "Xyes" ] \
		|| [ "X$inst_all" = "Xyes" ]  || [ "X$poldek_fetch" = "Xyes" ]; then
		dml_ok="yes"
	fi
	dml_cancel_check ${EXEC_PREFIX}/pldconf
	dml_help_check ${DATA_DIR}/POMOC/README_poldek.txt
	dml_check_the_rest ${EXEC_PREFIX}/pldconf
}

print_help()
{
	cat << EOF
$(nls "Options"):
-s   $(nls "synchronize index");
-a   $(nls "install all");
-e   $(nls "install editors");
-X   $(nls "install X section");
-N   $(nls "install original nvidia driver");
-I   $(nls "install Other section");
-o   $(nls "install About system section");
-c   $(nls "install devel packages");
-i   $(nls "install packages from command line. Use quotation if you install
more than one package eg.") -i "rox mozilla gimp"
-f <$(nls "package")>  $(nls "download packages to current directory");
-h   $(nls "help");
$(nls "no options run GUI")
EOF
}

while getopts "saeXNdSbnpIoci:f:h" opt
do
	case $opt in
		s ) sync="yes";;
		a ) inst_all="yes";;
		e ) edytory="yes";;
		X ) X="yes";;
		N ) X_in="X_nvidia"; X="yes";;
		d ) desktop="yes";;
		S ) smb="yes";;
		b ) boot="yes";;
		n ) net="yes";;
		p ) printer="yes";;
		I ) inne="yes";;
		o ) info="yes";;
		c ) devel="yes";;
		i ) install_packets_command_line="$OPTARG";;
		f ) poldek_file_fetch=$OPTARG; poldek_fetch="yes";;
		h ) print_help; exit;; 
		? ) print_help; exit;; 
	esac
done

[ -z "$1" ] && gui || run_main 2>/dev/null
