#!/bin/bash
# GPL, mimooh at pld-linux.org

run_main () {
	backup_file /etc/poldek.conf
	[ "X$conf" = "Xyes" ] && {
		install_if_missing eject
		cat > /etc/poldek.conf << EOF 
#If you have got more CDs, you can add it using the same way
#e.g. source6 = cd6,pri=-10 cdrom://ac-cd1/cd1/
#     prefix6 = cdrom://ac-cd6/PLD/RPMS

#For local builder e.g.
# source7 = home-builder,type=dir /home/users/teodor/rpm/RPMS

cdrom_get     = /usr/bin/vfjuggle %d %Pn

#Potrzebne do instalacji z sieci. Pozostae opcje w plikach przykadowych w /usr/share/doc/poldek/
#source8 = ra http://ftp.pld-linux.org/dists/ra/PLD/i386/PLD/RPMS/
#source9 = ra-updates-security http://ftp.pld-linux.org/dists/ra/updates/security/i386/
#source10 = ra-updates-general http://ftp.pld-linux.org/dists/ra/updates/general/i386/

#For new AC distribution 
#source8 = ac,pri=10 http://ftp.pld-linux.org/dists/ac/PLD/i386/PLD/RPMS/
#source9 = ac-updates-security,pri=20 http://ftp.pld-linux.org/dists/ac/updates/security/i386/
#source10 = ac-updates-general,pri=10 http://ftp.pld-linux.org/dists/ac/updates/general/i386/
EOF
		echo "VF_MNTPOINT=/media/cdrom" > /root/.vfjugglerc
		echo "VF_EJECT=\"eject\"" >> /root/.vfjugglerc
		echo "VF_MNTPOINT=/media/cdrom" > ~/.vfjugglerc
		echo "VF_EJECT=\"eject\"" >> ~/.vfjugglerc
		poldek --up || poldek --upa
	}
	[ "X$packets_dir" = "Xyes" ] && {
		mkdir -p /etc/pldconf/poldek/
		poldek --mkidxz -s /etc/pldconf/poldek/ --prefix=$packets_here --nodiff && index_ok=yes
		show_verbose_message " "
		[ -n "$index_ok" ] && {
			line_replace "source0" "source0 = /etc/pldconf/poldek/" /etc/poldek.conf 
			line_replace "prefix0" "prefix0 = $packets_here" /etc/poldek.conf 
		}
	}

	[ "X$hold" = "Xyes" ] && line_replace "hold" "hold = *" /etc/poldek.conf
	[ "X$keep" = "Xyes" ] && line_replace "keep_downloads" "keep_downloads = yes" /etc/poldek.conf
	[ "X$rebuilddb" = "Xyes" ] && {
		echo "$(nls "Rebuilding rpm database...")"
		rpm --rebuilddb
		show_message "$(nls "Database rebuilt")"
	}
}

gui () {
	eval `dml << EOF
	Poldek:<br>
	<check id=conf> $(nls "create basic /etc/poldek.conf file")<br>
	<check id=packets_dir> $(nls "rpm packages in folder:") <input id=packets_here width=28 fs=d label=Wybierz><br>
	<check id=hols> $(nls "Don't install if I have older version (hold)")<br>
	<check id=keep> $(nls "Don't remove donwloaded rpm files (keep_downloads)")<br>
	<check id=rebuilddb> $(nls "Rebuild rpm database (use if rpm database is broken)")<br><br>
	------------------------------------------------------------------<br><br>
	\`dml_buttons Ok Anuluj Edytuj Przywr Pomoc Wyjcie\`<br>
EOF`
	dml_cancel_check ${DATA_DIR}/poldek.sh
	dml_edit_check /etc/poldek.conf
	dml_recover_check ${CONF_DIR}/poldek.conf /etc/poldek.conf
	dml_help_check ${DATA_DIR}/POMOC/README_ustawienia.txt
	dml_check_the_rest ${EXEC_PREFIX}/pldconf
}

gui
