#!/bin/bash
# GPL, mimooh at pld-linux.org
# this is example how to use functions and how to build modules
# for pldconf. This module changes entries in /tmp/pldconf.wzorzec

run_main() { # 4: main program
	install_if_missing qcad
	line_replace "foo1" "foo1=$var1" /tmp/pldconf.wzorzec
	line_replace "foo2" "foo2=$var2" /tmp/pldconf.wzorzec
	line_replace "foo3" "foo3=$var3" /tmp/pldconf.wzorzec
	[ "X$var4" = "Xyes" ] && echo "$(nls "Checked [X] yes/no")"
	show_message "$(nls "End...")"
}

gui () { # 2: show form and sets variable
	eval `dml<< EOF
		<meta title="$(nls "Template")"><br><br>
		$(nls "This module shows how nice it is to use dml")<br>
		$(nls "Look on [Show source] and /tmp/pldconf.wzorzec")<br>
		$(nls "Set 'Verbose mode' in pldconf->Settings")<br><br>
		$(nls "Field input"): <input id=var1 width=16><br><br>
		$(nls "Field input"): <input id=var2 caption="domylny tekst"><br><br>
		$(nls "Select one of this options")
		<menu id=var3>
		<item id=jedynka> $(nls "1 choice")
		<item id=dwjka> $(nls "2 choice")
		<item id=trjka> $(nls "3 choice")
		</menu><br>
		<check id=var4 checked=0> $(nls "yes/no")<br><br>
		\`dml_buttons Ok Anuluj Edytuj Pomoc\`
EOF`
	cat << EOT 
	$(nls "variables set by dml"):
	var1=$var1
	var2=$var2
	var3=$var3
	var4=$var4

	dml_ok=$dml_ok, dml_cancel=$dml_cancel, dml_edit=$dml_edit, dml_help=$dml_help
       	dml_source=$dml_source, dml_exit=$dml_exit
EOT
	show_message " " # while to see results (enter/timeout - pldconf -> Settings)

	dml_cancel_check ${EXEC_PREFIX}/pldconf
	dml_edit_check /tmp/pldconf.wzorzec
	dml_help_check ${DATA_DIR}/POMOC/README_template.txt
	dml_check_the_rest ${EXEC_PREFIX}/pldconf # 3: this function is responded for execute run_main function
}


show_message "$(nls "Start...")" # 1: here start program
gui 
