#!/bin/bash
# 
# user.sh	This module is responsible for manage users. It has got
#		basic functions like adding deleting users and changing
#		information about them
#
# Author:	Krzysztof Malisiewicz <kinium at go2.pl>
# Changes:	Karol Kreski <mimooh at pld-linux.org>,
#		Jakub Krajniak <teodor at pld-linux.org>
# Licence:	GPL
#
# $Id:$
#

# stale
home="/home/users/"
shel="/bin/bash"
group="users"
pass=1
unset adgroup
unset prom

################## powloki ##########
for i in `cat /etc/shells`; do
	shells=$shells"<item id=$i>$i"
done
shells="<menu hidden=1 id=shellmenu>$shells</menu>"
################## end powloki ######

gui_main()
{
	eval `dml<<EOF
	<meta title=$(nls "Accounts")>
	<menu res=1 id=menu>
	<item id=edituser>$(nls "Edit user data")
	<item id=adduser>$(nls "Add user")
	<item id=deluser>$(nls "Delete user")
	<item id=powrot>$(nls "Back")
	<item id=exit>$(nls "Exit")
	</menu>
EOF`
}

gui_add()
{
eval `dml<< EOF
  <meta title="$(nls "Add user")">
  $(nls "Full name"): <input id=prom caption=$prom><br>
  $(nls "Login"): <input id=login_name caption=$login><br>
  $(nls "Home directory"): <input id=kat_home caption=$home><br>$shells
  $(nls "Shell"): <input id=shel menu=shellmenu caption=$shel><br>
  $(nls "Group"): <input id=group caption=$group><br>
  $(nls "Additional groups"): <input id=adgroup ><br>
  <check id=mkdir checked=1> $(nls "Create home directory if it doesn't exist yet")<br>
  <check id=home_etc checked=1> $(nls "Enable HOME_ETC")<br>
  <check id=set_pass checked=1> $(nls "Set password")<br>
	\`dml_buttons Ok Anuluj\`
EOF`
}	

gui_search()
{
	eval `dml<< EOF
	<meta title="$(nls "Find user")"><br>
	$(nls "You can use *, ?, ., marks")<br>
	$(nls "Login or name:")
	<input id=find res=1><br>         <button id=ok caption=$(nls "Find")>
EOF`
}

gui_ch_passwd()
{
	eval `dml << EOF
	<meta title="$(nls "Change user password")">
	$(nls "New password"):<input id=newpass pass=$pass caption=$password><br>
	$(nls "Repeat password"):<input id=pnewpass pass=$pass caption=$password><br>
	<button id=ok caption=$(nls "Ok")>  <button id=can caption=$(nls "Cancel")>
EOF`

}

gui_edit()
{
	eval `dml << EOF
	<meta title="$(nls "Change user data")">
	$(nls "User"): $login<br>
	$(nls "Name"): $prom<br>
	$(nls "Home directory"): $home6<br>
	$(nls "Shell"): $home7<br>
	$(nls "Last login"): $last_log<br>
	$(nls "Last password changed"): $ilednitemu<br>$timeout
	--------------------------------------------------<br>
	<button id=but1 caption="$(nls "Change password")" res=1>    
	<button id=but3 caption="$(nls "Change groups")" res=2><br><br>
        <button id=help caption="$(nls "Help")" res=5>
        <button id=ok caption="$(nls "Exit")" res=6>
EOF`
}

gui_grupy()
{
	eval `dml <<EOF
	<meta title="$(nls "Change user groups")">$(nls "Select new groups for user"): $login 
	<menu id=grupy height=15>$dml_grupy</menu><br>
	<button id=ok caption="$(nls "Save")"><button id=cancel caption=$(nls "Cancel")>
EOF`
}

gui_del()
{
	eval `dml << EOF
	<meta title="$(nls "Delete user")">
	$(nls "Do you want to delete user"):<br>
	$selected ($prom)?<br><br>
	<check id=rmdir> $(nls "Delete home directory")<br>
	<check id=force_mode> $(nls "logout user if logged in")<br>
	<button id=ok caption=$(nls "Yes")> <button id=no caption=$(nls "No")>
EOF`
}

add ()
{
	unset login
	unset prom
	
	gui_add
	
	if [ $dml_ok = "yes" ]
	then
		# adding user here
		if [ -z "$login_name" ]
		then 
			show_message "$(nls "Login name is not set")"
		else
			adgroup="`echo $adgroup | sed -e 's/ /,/g;'`"
			group="`echo $group | sed -e 's/ /,/g;'`"
			cmd="/usr/sbin/useradd "
			[ -n "${shel}" ] && cmd="$cmd-s $shel "
			[ -n "${kat_home}" ] && cmd="$cmd-d $home$login_name "
			[ -n "${prom}" ] && cmd="$cmd-c \"$prom\" "
			[ -n "${group}" ] && cmd="$cmd-g $group "
			[ -n "${adgroup}" ] && cmd="$cmd-G $adgroup "
			[ -n ${mkdir} ] && cmd=$cmd"-m "
			cmd=$cmd"$login_name"
			
			eval $cmd
	
			[ "X$set_pass" = "Xyes" ] && { login=$login_name; ch_passwd; }
			#HOME_ETC
			[ "X$home_etc" = "Xyes" ] && {
				echo "etc" > /home/users/$login_name/.home_etc
				mkdir /home/users/$login_name/etc
				chown -R $login_name:users /home/users/$login_name/*
				chmod -R 0700 /home/users/$login_name/etc
			}
		fi
	fi
}

search()
{
	unset selected
	unset result
	
	gui_search
	
	if [ -n "$find" ]; then
		tab=(`cat /etc/passwd|egrep -i "$find"|cut -f 1 -d':'`); 
		i=${#tab[@]};
		if [ $i -gt 0 ]; then
			if [ $i -gt 1 ]; then
				i=0
				for lo in ${tab[@]}
				do
					items=$items"<item id=$i>$lo - "`cat /etc/passwd|grep -i "/$lo:"|cut -f 5 -d':'`
					let i++
				done
				eval `dml << EOF
				<meta title="$(nls "Select user")">
				<menu id=menu res=1>
				$items</menu><br><button res=2 caption=$(nls "Cancel")>
EOF`
				if [ $res -eq 1 ]
				then
					selected=${tab[$menu]}
					result=true
				fi
			else
				selected=$tab
				result=true
			fi
		else
			show_message "$(nls "$find not found")"
		fi
	fi
	tm=`cat /etc/passwd|grep ^$selected:`
	prom=`echo $tm|cut -f 5 -d:`
	home6=`echo $tm|cut -f 6 -d:`
	home7=`echo $tm|cut -f 7 -d:`
}

ch_passwd()
{
	# zmiana hasla
	gui_ch_passwd
	
	if [ "$ok" = "yes" ]
	then
		if [ "$newpass" = "$pnewpass" ]
		then
			# nie wiem czy to rozwiazanie jest 
			# bezpieczne ?? 
			echo $login\:$newpass| chpasswd
			show_message "$(nls "Password was changed")"
		else
						show_message "$(nls "Passwords don't match")"
		fi
	fi
}


about_user()
{
	last_log=`lastlog -u $login|grep $login|cut -b 44-73`
	us=`cat /etc/shadow|grep $login`
	user3=`echo $us|cut -f3 -d:`
	user5=`echo $us|cut -f5 -d:`

	ilednitemu=$[($(date +%s)/86400 - $user3)]
	[ $ilednitemu -gt $user5 ] && timeout="      !!! $(nls "Time to change password") !!!<br>" || timeout=""
}

pomoc()
{
	show_message "$(nls "You have to add user to audio group, if
	you want them to play sound. If you want users
	to record CDs, you have to add them to disk group")"
}
	
edit()
{
	search
	if [ -n "$result" ]
	then
		login=$selected
		koniec=true
		while $koniec; do
			about_user
			gui_edit

		case $res in
			1) ch_passwd ;;
			2) grupy ;;
			5) pomoc ;;
			6) koniec=false	;;
		esac
		
		done
	fi
}


grupy ()
{
	if [ -n "$login" ]
	then
		unset dml_grupy
		for i in `cat /etc/group`
		do
			grupa=`echo $i|cut -f1 -d:`
			[ `echo $i|grep $login` ] && gr=1 || gr=0
		       	dml_grupy=$dml_grupy"<item id=$grupa checked=$gr>$grupa"
		done
		gui_grupy
		if [ $ok = yes ]
		then
			groups=`echo $grupy|sed s/" "/","/g`
			usermod -G $groups $login
		fi
	fi
}


del ()
{
	search
	if [ -n "$result" ]
	then
		gui_del
		if [ "$ok" = "yes" ]; then
			[ $force_mode = yes ] && logout_user $selected
			[ $rmdir = yes ] && userdel -r $selected >& /dev/null || userdel $selected >& /dev/null
			case $? in
				0) show_message "$(nls "User was deleted from system")";;
				8) show_message "$(nls "$selected is logged in, please logout user, use force mode.")";;
				12) show_message "$(nls "Can't deleted user home director")";;
			esac
		fi
	fi
}


logout_user ()
{
	ps -u $1 | column -t | cut -f1 -d' ' | grep -v PID | while read i; do
		kill -9 $i
	done
}

gui ()
{
	gui_main
	
	case $menu in
		edituser)
		edit
		exec ${DATA_DIR}/user.sh
		;;
		adduser)
		add
		exec ${DATA_DIR}/user.sh
		;;
		deluser)
		del
		exec ${DATA_DIR}/user.sh
		;;
		powrot)
		exec ${EXEC_PREFIX}/pldconf
		;;
	esac
}

gui

